'
' Transmit the value read from the ADC on AN0
'
' View the results via the serial terminal set to the com port that the USB connects too.
'
	Device = 18F4550								' Choose a device with on-board full speed USB
    XTAL = 48										' Set the oscillator speed to 48MHz (using a 20MHz crystal)
    
    REMINDERS = OFF									' Disable all reminders
          
    USB_DESCRIPTOR = "CDCDESC.ASM"					' Point to the CDC DESCRIPTOR file (located in the INC\USB_18 folder)
    'USBIN_AUTO_POLL = OFF							' Enable\Disable Auto polling from within the USBIN command (default is Enabled)
	'USBOUT_AUTO_POLL = OFF 						' Enable\Disable Auto polling from within the USBOUT command (default is Enabled)
	'USB_SENSE_PIN = PORTB.0						' Low to Disable the USB interface (optional)
    'USB_SELF_POWER_PIN = PORTB.1					' Low for Self Powered Mode (optional)
    
    Dim PP0 as Byte SYSTEM							' USBPOLL status return
    Dim AD_RESULT 	as ADRESL.Word			
	Dim Value 		as Word
    Dim Volts 		as Byte
    Dim Millivolts 	as Word	
    
    Dim ARRAY1[20] as Byte 							' Used to hold some output characters
   	Dim OUT_BUFFER as String * 20					' Used to hold some output characters
    Dim IN_BUFFER as String * 20					' Used to hold some input characters
    
    Symbol CARRY_FLAG = STATUS.0					' High if microcontroller does not have control over the DP buffer
    Symbol TRNIF = UIR.3							' Low if USB Busy
'------------------------------------------------------------------------
' The main program loop starts here 
   
    Delayms 200										' Wait for things to stabilise
    ALL_DIGITAL = True								' Set PORTA and PORTD to digital mode
    Clear											' Clear all RAM before we start 
   	
    Repeat											' \
    	USBPoll										'   Wait for the USB interface to become attached
    Until PP0 = %00000110							' /
    
    TRISA.0 = 1										' Setup PORTA.0 as an input
    ADCON1 = %10001110								' Make PORTA.0 analogue
    ADCON2 = %10000000								' Right justify ADC result
    
IDLELOOP:
	While 1 = 1										' Create an infinite loop
 		AD_RESULT = Adin 0							' Read the ADC
        Value = 489 * (AD_RESULT / 10)				' Quantasize the result
		Volts = Value / 10000
		Millivolts = (Value // 10000) / 100
         
		OUT_BUFFER = Str$(Dec1,Volts) + "." + Str$(Dec2,Millivolts) + "\n\r" 
    	Repeat  
			USBOut 3, OUT_BUFFER, AUTO 				' Poll the USB and transmit the buffer from endpoint 3
    	Until CARRY_FLAG = 0						' Keep trying if the microcontroller does not have control over the buffer
        Repeat : Until TRNIF = 1					' Wait for completion before continuing
    Wend											
    
